"use strict";
/*
 * Copyright 2020 NEM
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
Object.defineProperty(exports, "__esModule", { value: true });
const command_1 = require("@oclif/command");
const service_1 = require("../service");
const AnnounceService_1 = require("../service/AnnounceService");
class Supernode extends command_1.Command {
    async run() {
        const { flags } = this.parse(Supernode);
        service_1.BootstrapUtils.showBanner();
        return new service_1.BootstrapService(this.config.root).supernode(flags);
    }
}
exports.default = Supernode;
Supernode.description = `It registers the nodes in the supernode rewards program by announcing the enrol transaction to the registration address.`;
Supernode.examples = [`$ symbol-bootstrap supernode`];
Supernode.flags = Object.assign({ help: service_1.BootstrapUtils.helpFlag, target: service_1.BootstrapUtils.targetFlag }, AnnounceService_1.AnnounceService.flags);
