import { flags } from '@oclif/command';
import { Account, AccountInfo, ChainInfo, Deadline, RepositoryFactory, Transaction, UInt64 } from 'symbol-sdk';
import { Addresses, ConfigPreset, NodeAccount, NodePreset } from '../model';
export interface TransactionFactoryParams {
    presetData: ConfigPreset;
    nodePreset: NodePreset;
    nodeAccount: NodeAccount;
    mainAccountInfo: AccountInfo;
    mainAccount: Account;
    deadline: Deadline;
    maxFee: UInt64;
}
export interface TransactionFactory {
    createTransactions(params: TransactionFactoryParams): Promise<Transaction[]>;
}
export interface RepositoryInfo {
    repositoryFactory: RepositoryFactory;
    restGatewayUrl: string;
    generationHash?: string;
    chainInfo?: ChainInfo;
}
export declare class AnnounceService {
    private static onProcessListener;
    static flags: {
        password: flags.IOptionFlag<string>;
        url: flags.IOptionFlag<string>;
        useKnownRestGateways: import("@oclif/parser/lib/flags").IBooleanFlag<boolean>;
        maxFee: import("@oclif/parser/lib/flags").IOptionFlag<number | undefined>;
    };
    announce(providedUrl: string, providedMaxFee: number | undefined, useKnownRestGateways: boolean, presetData: ConfigPreset, addresses: Addresses, transactionFactory: TransactionFactory, tokenAmount?: string): Promise<void>;
    private promptAccounts;
    static isValidPrivateKey(input: string): boolean | string;
    private getAccountInfo;
    private getMultisigAccount;
    private getKnownNodeRepositoryInfos;
    private sortByHeight;
    private getBestCosigner;
    private isAccountEmpty;
}
