import { Account, NetworkType } from 'symbol-sdk';
import { Addresses, ConfigAccount, ConfigPreset, NodeAccount, NodePreset } from '../model';
import { Migration, Password } from './BootstrapUtils';
import { Preset } from './ConfigService';
export declare class ConfigLoader {
    private static presetInfoLogged;
    generateRandomConfiguration(presetData: ConfigPreset): Promise<Addresses>;
    generateAddresses(networkType: NetworkType, size: number): ConfigAccount[];
    generateAccount(networkType: NetworkType, privateKey: string | undefined): Account;
    generateNodeAccount(presetData: ConfigPreset, index: number, nodePreset: NodePreset, networkType: NetworkType): NodeAccount;
    generateNodeAccounts(presetData: ConfigPreset, networkType: NetworkType): Promise<NodeAccount[]>;
    private static getArray;
    createPresetData({ password, root, preset, assembly, customPreset, customPresetObject, }: {
        password: string | undefined;
        root: string;
        preset: Preset;
        assembly?: string;
        customPreset?: string;
        customPresetObject?: any;
    }): ConfigPreset;
    dynamicDefaultNodeConfiguration(nodes?: NodePreset[]): NodePreset[];
    private resolveRoles;
    static toConfig(account: Account): ConfigAccount;
    expandRepeat(presetData: ConfigPreset): ConfigPreset;
    applyValueTemplate(context: any, value: any): any;
    expandServicesRepeat(context: any, services: any[]): any[];
    loadExistingPresetDataIfPreset(target: string, password: Password): ConfigPreset | undefined;
    loadExistingPresetData(target: string, password: Password): ConfigPreset;
    loadExistingAddressesIfPreset(target: string, password: Password): Addresses | undefined;
    migrateAddresses(addresses: any, networkType: NetworkType): Addresses;
    getAddressesMigration(networkType: NetworkType): Migration[];
    loadExistingAddresses(target: string, password: Password): Addresses;
    getGeneratedPresetLocation(target: string): string;
    getGeneratedAddressLocation(target: string): string;
}
