import { Deadline, Transaction, UInt64 } from 'symbol-sdk';
import { Addresses, ConfigPreset, NodeAccount, NodePreset } from '../model';
import { TransactionFactory } from './AnnounceService';
export declare type SupernodeParams = {
    target: string;
    readonly password?: string;
    url: string;
    maxFee?: number;
    useKnownRestGateways: boolean;
};
export interface SupernodeServiceTransactionFactoryParams {
    presetData: ConfigPreset;
    nodePreset: NodePreset;
    nodeAccount: NodeAccount;
    deadline: Deadline;
    maxFee: UInt64;
}
export declare class SupernodeService implements TransactionFactory {
    protected readonly params: SupernodeParams;
    static readonly defaultParams: SupernodeParams;
    private readonly configLoader;
    constructor(params: SupernodeParams);
    enroll(passedPresetData?: ConfigPreset | undefined, passedAddresses?: Addresses | undefined): Promise<void>;
    createTransactions({ presetData, nodePreset, nodeAccount, deadline, maxFee, }: SupernodeServiceTransactionFactoryParams): Promise<Transaction[]>;
}
